#ifndef _FTL_RECONSTRUCTION_CAMERA_CUDA_HPP_
#define _FTL_RECONSTRUCTION_CAMERA_CUDA_HPP_

#include <ftl/depth_camera.hpp>
#include <ftl/voxel_hash.hpp>

namespace ftl {
namespace cuda {

void clear_depth(const TextureObject<float> &depth, cudaStream_t stream);

void mls_smooth(TextureObject<float> &output, const ftl::voxhash::HashData &hashData, const ftl::voxhash::HashParams &hashParams, int numcams, int cam, cudaStream_t stream);

void point_cloud(float3* output, const ftl::voxhash::DepthCameraCUDA &depthCameraData, cudaStream_t stream);

void compute_normals(const float3 *points, ftl::cuda::TextureObject<float4> *normals, cudaStream_t stream);

}
}

#endif  // _FTL_RECONSTRUCTION_CAMERA_CUDA_HPP_
